package com.example.demo.movies.repository;

import java.util.List;
import java.util.Optional;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.CrudRepository;
import org.springframework.data.repository.PagingAndSortingRepository;

import com.example.demo.movies.model.MovieEntity;

public interface MovieRepository
        extends CrudRepository<MovieEntity, Long>, PagingAndSortingRepository<MovieEntity, Long> {
    Optional<MovieEntity> findByTitleIgnoreCase(String title);

    List<MovieEntity> findByTypeId(Long typeId);

    Page<MovieEntity> findByTypeId(long typeId, Pageable pageable);

    List<MovieEntity> findByAgeRatingId(Long ageRatingId);

    Page<MovieEntity> findByAgeRatingId(Long ageRatingId, Pageable pageable);

    List<MovieEntity> findByTypeIdAndAgeRatingId(Long typeId, Long ageRatingId);

    Page<MovieEntity> findByTypeIdAndAgeRatingId(Long typeId, Long ageRatingId, Pageable pageable);

    @Query("SELECT CAST(SUM(r.rate) as double) / COUNT(*) as average_rate FROM MovieEntity as m JOIN ReviewEntity as r ON r.movie.id=m.id WHERE m.id=?1")
    Double getAverageRating(long id);
}
