package com.example.demo.reviews.model;

import java.util.Objects;

import com.example.demo.core.model.BaseEntity;
import com.example.demo.movies.model.MovieEntity;
import com.example.demo.users.model.UserEntity;

import jakarta.persistence.Column;
import jakarta.persistence.Entity;
import jakarta.persistence.JoinColumn;
import jakarta.persistence.ManyToOne;
import jakarta.persistence.Table;

@Entity
@Table(name = "reviews")
public class ReviewEntity extends BaseEntity {
    @ManyToOne
    @JoinColumn(name = "userId", nullable = false)
    private UserEntity user;
    @ManyToOne
    @JoinColumn(name = "movieId", nullable = false)
    private MovieEntity movie;
    @Column(nullable = false)
    private String description;
    @Column(nullable = false)
    private Integer rate;

    public ReviewEntity() {
    }

    public ReviewEntity(String description, Integer rate) {
        this.description = description;
        this.rate = rate;
    }

    public UserEntity getUser() {
        return user;
    }

    public void setUser(UserEntity user) {
        this.user = user;
    }

    public MovieEntity getMovie() {
        return movie;
    }

    public void setMovie(MovieEntity movie) {
        this.movie = movie;
    }

    public String getDescription() {
        return description;
    }

    public void setDescription(String description) {
        this.description = description;
    }

    public Integer getRate() {
        return rate;
    }

    public void setRate(Integer rate) {
        this.rate = rate;
    }

    @Override
    public int hashCode() {
        return Objects.hash(id, user, movie, description, rate);
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj)
            return true;
        if (obj == null || getClass() != obj.getClass())
            return false;
        final ReviewEntity other = (ReviewEntity) obj;
        return Objects.equals(other.getId(), id)
                && Objects.equals(other.getUser(), user)
                && Objects.equals(other.getMovie(), movie)
                && Objects.equals(other.getDescription(), description)
                && Objects.equals(other.getRate(), rate);
    }
}
