package com.example.demo.reviews.repository;

import com.example.demo.reviews.model.ReviewEntity;

import java.util.List;
import java.util.Optional;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.data.repository.CrudRepository;
import org.springframework.data.repository.PagingAndSortingRepository;

public interface ReviewRepository
        extends CrudRepository<ReviewEntity, Long>, PagingAndSortingRepository<ReviewEntity, Long> {
    List<ReviewEntity> findByUserId(long userId);

    Page<ReviewEntity> findByUserId(long userId, Pageable pageable);

    List<ReviewEntity> findByMovieId(long movieId);

    Page<ReviewEntity> findByMovieId(long movieId, Pageable pageable);

    Optional<ReviewEntity> findOneByUserIdAndId(long userId, long id);

    Optional<ReviewEntity> findOneByUserIdAndMovieId(long userId, long movieId);

    List<ReviewEntity> findByUserIdAndMovieId(long userId, long movieId);

    Page<ReviewEntity> findByUserIdAndMovieId(long userId, long movieId, Pageable pageable);
}
