package com.example.demo.users.repository;

import java.util.Date;
import java.util.List;
import java.util.Optional;

import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.CrudRepository;
import org.springframework.data.repository.PagingAndSortingRepository;
import org.springframework.data.repository.query.Param;

import com.example.demo.users.model.UserEntity;
import com.example.demo.usersubscription.model.UserSubscriptionEntity;

public interface UserRepository extends CrudRepository<UserEntity, Long>, PagingAndSortingRepository<UserEntity, Long> {
    Optional<UserEntity> findByEmailIgnoreCase(String login);

    @Query("SELECT us FROM UserSubscriptionEntity us WHERE us.user.id = :userId AND us.expirationDate > :now")
    List<UserSubscriptionEntity> getActiveSubscriptions(@Param("userId") Long userId, @Param("now") Date now);
}
